// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOpenGLFunctions_ES2Wrapper_H
#define SBK_QOpenGLFunctions_ES2Wrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_es2.h>

class QOpenGLFunctions_ES2Wrapper : public QOpenGLFunctions_ES2
{
public:
    QOpenGLFunctions_ES2Wrapper(const QOpenGLFunctions_ES2Wrapper &) = delete;
    QOpenGLFunctions_ES2Wrapper& operator=(const QOpenGLFunctions_ES2Wrapper &) = delete;
    QOpenGLFunctions_ES2Wrapper(QOpenGLFunctions_ES2Wrapper &&) = delete;
    QOpenGLFunctions_ES2Wrapper& operator=(QOpenGLFunctions_ES2Wrapper &&) = delete;

    QOpenGLFunctions_ES2Wrapper();
    bool initializeOpenGLFunctions() override;
    ~QOpenGLFunctions_ES2Wrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOpenGLFunctions_ES2Wrapper_H

